/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.73 Revision 1.129
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.73 2004/10/13 14:11:52 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.129 2009/01/04 17:22:16 vapier Exp $
4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
4# 21#
5# Author Bart Verwilst <verwilst@gentoo.org> 22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
6 27
7ECLASS=flag-o-matic
8INHERITED="$INHERITED $ECLASS"
9 28
10# Please leave ${IUSE} in this until portage .51 is stable, otherwise
11# IUSE gets clobbered.
12IUSE="${IUSE} debug"
13
14# need access to emktemp()
15inherit eutils
16
17#
18#### filter-flags <flags> ####
19# Remove particular flags from C[XX]FLAGS
20# Matches only complete flags
21#
22#### append-flags <flags> ####
23# Add extra flags to your current C[XX]FLAGS
24#
25#### replace-flags <orig.flag> <new.flag> ###
26# Replace a flag by another one
27#
28#### replace-cpu-flags <old.cpus> <new.cpu> ###
29# Replace march/mcpu flags that specify <old.cpus>
30# with flags that specify <new.cpu>
31#
32#### is-flag <flag> ####
33# Returns "true" if flag is set in C[XX]FLAGS
34# Matches only complete a flag
35#
36#### strip-flags ####
37# Strip C[XX]FLAGS of everything except known
38# good options.
39#
40#### strip-unsupported-flags ####
41# Strip C[XX]FLAGS of any flags not supported by
42# installed version of gcc
43#
44#### get-flag <flag> ####
45# Find and echo the value for a particular flag
46#
47#### replace-sparc64-flags ####
48# Sets mcpu to v8 and uses the original value
49# as mtune if none specified.
50#
51#### filter-mfpmath <math types> ####
52# Remove specified math types from the fpmath specification
53# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
54# will leave the user with -mfpmath=386
55#
56#### append-ldflags ####
57# Add extra flags to your current LDFLAGS
58#
59#### filter-ldflags <flags> ####
60# Remove particular flags from LDFLAGS
61# Matches only complete flags
62#
63#### etexec-flags ####
64# hooked function for hardened gcc that appends
65# -fno-pic to {C,CXX,LD}FLAGS
66# when a package is filtering -fpic, -fPIC, -fpie, -fPIE
67#
68#### fstack-flags ####
69# hooked function for hardened gcc that appends
70# -fno-stack-protector to {C,CXX,LD}FLAGS
71# when a package is filtering -fstack-protector, -fstack-protector-all
72# notice: modern automatic specs files will also suppress -fstack-protector-all
73# when only -fno-stack-protector is given
74#
75
76# C[XX]FLAGS that we allow in strip-flags 29# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
77setup-allowed-flags() { 31setup-allowed-flags() {
78 if [ -z "${ALLOWED_FLAGS}" ] ; then 32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
79 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -fno-stack-protector -fno-pie -fno-unit-at-a-time -pipe -g" 33 export ALLOWED_FLAGS="-pipe"
34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-strict-overflow"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
41 fi
42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 -msecure-plt -m*-toc -D* -U*"
55
56 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
57 # NOTE: currently -Os have issues with gcc3 and K6* arch's
58 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
59 return 0
60}
61
62# inverted filters for hardened compiler. This is trying to unpick
63# the hardened compiler defaults.
64_filter-hardened() {
65 local f
66 for f in "$@" ; do
80 case "${ARCH}" in 67 case "${f}" in
81 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 -EL -EB -mabi" ;; 68 # Ideally we should only concern ourselves with PIE flags,
82 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC -m64" ;; 69 # not -fPIC or -fpic, but too many places filter -fPIC without
83 x86) ALLOWED_FLAGS="${ALLOWED_FLAGS} -m32" ;; 70 # thinking about -fPIE.
84 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 71 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
85 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 72 gcc-specs-pie || continue
73 is-flagq -nopie || append-flags -nopie;;
74 -fstack-protector)
75 gcc-specs-ssp || continue
76 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
77 -fstack-protector-all)
78 gcc-specs-ssp-to-all || continue
79 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
80 -fno-strict-overflow)
81 gcc-specs-nostrict || continue
82 is-flagq -fstrict-overflow || append-flags -fstrict-overflow;;
86 esac 83 esac
87 fi 84 done
88 # allow a bunch of flags that negate features / control ABI
89 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all"
90 case "${ARCH}" in
91 x86|amd64|ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow" ;;
92 esac
93 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs -msoft-float -mflat -mno-faster-structs -mfaster-structs -mlittle-endian -mbig-endian -mlive-g0 -mcmodel -mno-stack-bias -mstack-bias"
94
95 # C[XX]FLAGS that we are think is ok, but needs testing
96 # NOTE: currently -Os have issues with gcc3 and K6* arch's
97 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays"
98 return 0
99} 85}
100 86
87# Remove occurrences of strings from variable given in $1
88# Strings removed are matched as globs, so for example
89# '-O*' would remove -O1, -O2 etc.
90_filter-var() {
91 local f x VAR VAL
92 declare -a new
93
94 VAR=$1
95 shift
96 eval VAL=\${${VAR}}
97 for f in ${VAL}; do
98 for x in "$@"; do
99 # Note this should work with globs like -O*
100 [[ ${f} == ${x} ]] && continue 2
101 done
102 eval new\[\${\#new\[@]}]=\${f}
103 done
104 eval export ${VAR}=\${new\[*]}
105}
106
107# @FUNCTION: filter-flags
108# @USAGE: <flags>
109# @DESCRIPTION:
110# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
101filter-flags() { 111filter-flags() {
102 local x f fset 112 _filter-hardened "$@"
103 declare -a new_CFLAGS new_CXXFLAGS 113 _filter-var CFLAGS "$@"
104 114 _filter-var CPPFLAGS "$@"
105 for x in "$@" ; do 115 _filter-var CXXFLAGS "$@"
106 case "${x}" in 116 _filter-var FFLAGS "$@"
107 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;; 117 _filter-var FCFLAGS "$@"
108 -fstack-protector|-fstack-protector-all) fstack-flags;;
109 esac
110 done
111
112 for fset in CFLAGS CXXFLAGS; do
113 # Looping over the flags instead of using a global
114 # substitution ensures that we're working with flag atoms.
115 # Otherwise globs like -O* have the potential to wipe out the
116 # list of flags.
117 for f in ${!fset}; do
118 for x in "$@"; do
119 # Note this should work with globs like -O*
120 [[ ${f} == ${x} ]] && continue 2
121 done
122 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
123 done
124 eval export ${fset}=\${new_${fset}\[*]}
125 done
126
127 return 0 118 return 0
128} 119}
129 120
121# @FUNCTION: filter-lfs-flags
122# @DESCRIPTION:
123# Remove flags that enable Large File Support.
130filter-lfs-flags() { 124filter-lfs-flags() {
125 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
131 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 126 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
132} 127}
133 128
129# @FUNCTION: append-cppflags
130# @USAGE: <flags>
131# @DESCRIPTION:
132# Add extra <flags> to the current CPPFLAGS.
133append-cppflags() {
134 [[ -z $* ]] && return 0
135 export CPPFLAGS="${CPPFLAGS} $*"
136 return 0
137}
138
139# @FUNCTION: append-fflags
140# @USAGE: <flags>
141# @DESCRIPTION:
142# Add extra <flags> to the current {F,FC}FLAGS.
143append-fflags() {
144 [[ -z $* ]] && return 0
145 export FFLAGS="${FFLAGS} $*"
146 export FCFLAGS="${FCFLAGS} $*"
147 return 0
148}
149
150# @FUNCTION: append-lfs-flags
151# @DESCRIPTION:
152# Add flags that enable Large File Support.
134append-lfs-flags() { 153append-lfs-flags() {
154 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
135 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 155 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
136} 156}
137 157
158# @FUNCTION: append-flags
159# @USAGE: <flags>
160# @DESCRIPTION:
161# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
138append-flags() { 162append-flags() {
163 [[ -z $* ]] && return 0
139 export CFLAGS="${CFLAGS} $*" 164 export CFLAGS="${CFLAGS} $*"
140 export CXXFLAGS="${CXXFLAGS} $*" 165 export CXXFLAGS="${CXXFLAGS} $*"
141 [ -n "`is-flag -fno-stack-protector`" -o \ 166 export FFLAGS="${FFLAGS} $*"
142 -n "`is-flag -fno-stack-protector-all`" ] && fstack-flags 167 export FCFLAGS="${FCFLAGS} $*"
143 return 0 168 return 0
144} 169}
145 170
171# @FUNCTION: replace-flags
172# @USAGE: <old> <new>
173# @DESCRIPTION:
174# Replace the <old> flag with <new>. Accepts shell globs for <old>.
146replace-flags() { 175replace-flags() {
176 [[ $# != 2 ]] \
177 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
178 && die "replace-flags takes 2 arguments, not $#"
179
147 local f fset 180 local f fset
148 declare -a new_CFLAGS new_CXXFLAGS 181 declare -a new_CFLAGS new_CXXFLAGS new_FFLAGS new_FCFLAGS
149 182
150 for fset in CFLAGS CXXFLAGS; do 183 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
151 # Looping over the flags instead of using a global 184 # Looping over the flags instead of using a global
152 # substitution ensures that we're working with flag atoms. 185 # substitution ensures that we're working with flag atoms.
153 # Otherwise globs like -O* have the potential to wipe out the 186 # Otherwise globs like -O* have the potential to wipe out the
154 # list of flags. 187 # list of flags.
155 for f in ${!fset}; do 188 for f in ${!fset}; do
161 done 194 done
162 195
163 return 0 196 return 0
164} 197}
165 198
199# @FUNCTION: replace-cpu-flags
200# @USAGE: <old> <new>
201# @DESCRIPTION:
202# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
203# with flags that select the <new> cpu. Accepts shell globs for <old>.
166replace-cpu-flags() { 204replace-cpu-flags() {
167 local newcpu="$#" ; newcpu="${!newcpu}" 205 local newcpu="$#" ; newcpu="${!newcpu}"
168 while [ $# -gt 1 ] ; do 206 while [ $# -gt 1 ] ; do
169 # quote to make sure that no globbing is done (particularly on 207 # quote to make sure that no globbing is done (particularly on
170 # ${oldcpu} prior to calling replace-flags 208 # ${oldcpu}) prior to calling replace-flags
171 replace-flags "-march=${1}" "-march=${newcpu}" 209 replace-flags "-march=${1}" "-march=${newcpu}"
172 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}" 210 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
173 replace-flags "-mtune=${1}" "-mtune=${newcpu}" 211 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
174 shift 212 shift
175 done 213 done
176 return 0 214 return 0
177} 215}
178 216
217_is_flagq() {
218 local x
219 for x in ${!1} ; do
220 [[ ${x} == $2 ]] && return 0
221 done
222 return 1
223}
224
225# @FUNCTION: is-flagq
226# @USAGE: <flag>
227# @DESCRIPTION:
228# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
229is-flagq() {
230 [[ -n $2 ]] && die "Usage: is-flag <flag>"
231 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
232}
233
234# @FUNCTION: is-flag
235# @USAGE: <flag>
236# @DESCRIPTION:
237# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
179is-flag() { 238is-flag() {
180 local x 239 is-flagq "$@" && echo true
181
182 for x in ${CFLAGS} ${CXXFLAGS} ; do
183 # Note this should work with globs like -mcpu=ultrasparc*
184 if [[ ${x} == ${1} ]]; then
185 echo true
186 return 0
187 fi
188 done
189 return 1
190} 240}
191 241
242# @FUNCTION: is-ldflagq
243# @USAGE: <flag>
244# @DESCRIPTION:
245# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
246is-ldflagq() {
247 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
248 _is_flagq LDFLAGS $1
249}
250
251# @FUNCTION: is-ldflag
252# @USAGE: <flag>
253# @DESCRIPTION:
254# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
255is-ldflag() {
256 is-ldflagq "$@" && echo true
257}
258
259# @FUNCTION: filter-mfpmath
260# @USAGE: <math types>
261# @DESCRIPTION:
262# Remove specified math types from the fpmath flag. For example, if the user
263# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
264# -mfpmath=386.
192filter-mfpmath() { 265filter-mfpmath() {
193 local orig_mfpmath new_math prune_math 266 local orig_mfpmath new_math prune_math
194 267
195 # save the original -mfpmath flag 268 # save the original -mfpmath flag
196 orig_mfpmath="`get-flag -mfpmath`" 269 orig_mfpmath=$(get-flag -mfpmath)
197 # get the value of the current -mfpmath flag 270 # get the value of the current -mfpmath flag
198 new_math=" `get-flag mfpmath | tr , ' '` " 271 new_math=$(get-flag mfpmath)
272 new_math=" ${new_math//,/ } "
199 # figure out which math values are to be removed 273 # figure out which math values are to be removed
200 prune_math="" 274 prune_math=""
201 for prune_math in "$@" ; do 275 for prune_math in "$@" ; do
202 new_math="${new_math/ ${prune_math} / }" 276 new_math=${new_math/ ${prune_math} / }
203 done 277 done
204 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 278 new_math=$(echo ${new_math})
279 new_math=${new_math// /,}
205 280
206 if [ -z "${new_math}" ] ; then 281 if [[ -z ${new_math} ]] ; then
207 # if we're removing all user specified math values are 282 # if we're removing all user specified math values are
208 # slated for removal, then we just filter the flag 283 # slated for removal, then we just filter the flag
209 filter-flags ${orig_mfpmath} 284 filter-flags ${orig_mfpmath}
210 else 285 else
211 # if we only want to filter some of the user specified 286 # if we only want to filter some of the user specified
213 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 288 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
214 fi 289 fi
215 return 0 290 return 0
216} 291}
217 292
293# @FUNCTION: strip-flags
294# @DESCRIPTION:
295# Strip C[XX]FLAGS of everything except known good/safe flags.
218strip-flags() { 296strip-flags() {
219 local x y flag NEW_CFLAGS NEW_CXXFLAGS 297 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
220 298
221 setup-allowed-flags 299 setup-allowed-flags
222 300
223 local NEW_CFLAGS="" 301 local NEW_CFLAGS=""
224 local NEW_CXXFLAGS="" 302 local NEW_CXXFLAGS=""
303 local NEW_FFLAGS=""
304 local NEW_FCFLAGS=""
225 305
226 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 306 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
227 if has ~${ARCH} ${ACCEPT_KEYWORDS} ; then 307 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
228 use debug && einfo "Enabling the use of some unstable flags"
229 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 308 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
230 fi 309 fi
231 310
232 set -f # disable pathname expansion 311 set -f # disable pathname expansion
233 312
249 break 328 break
250 fi 329 fi
251 done 330 done
252 done 331 done
253 332
333 for x in ${FFLAGS}; do
334 for y in ${ALLOWED_FLAGS}; do
335 flag=${x%%=*}
336 if [ "${flag%%${y}}" = "" ] ; then
337 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
338 break
339 fi
340 done
341 done
342
343 for x in ${FCFLAGS}; do
344 for y in ${ALLOWED_FLAGS}; do
345 flag=${x%%=*}
346 if [ "${flag%%${y}}" = "" ] ; then
347 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
348 break
349 fi
350 done
351 done
352
254 # In case we filtered out all optimization flags fallback to -O2 353 # In case we filtered out all optimization flags fallback to -O2
255 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 354 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
256 NEW_CFLAGS="${NEW_CFLAGS} -O2" 355 NEW_CFLAGS="${NEW_CFLAGS} -O2"
257 fi 356 fi
258 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 357 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
259 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 358 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
260 fi 359 fi
360 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
361 NEW_FFLAGS="${NEW_FFLAGS} -O2"
362 fi
363 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
364 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
365 fi
261 366
262 set +f # re-enable pathname expansion 367 set +f # re-enable pathname expansion
263 368
264 export CFLAGS="${NEW_CFLAGS}" 369 export CFLAGS="${NEW_CFLAGS}"
265 export CXXFLAGS="${NEW_CXXFLAGS}" 370 export CXXFLAGS="${NEW_CXXFLAGS}"
371 export FFLAGS="${NEW_FFLAGS}"
372 export FCFLAGS="${NEW_FCFLAGS}"
373 return 0
374}
375
376test-flag-PROG() {
377 local comp=$1
378 local flags="$2"
379
380 [[ -z ${comp} || -z ${flags} ]] && \
266 return 0 381 return 1
267}
268 382
383 local PROG=$(tc-get${comp})
384 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
385 > /dev/null 2>&1
386}
387
388# @FUNCTION: test-flag-CC
389# @USAGE: <flag>
390# @DESCRIPTION:
391# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
392test-flag-CC() { test-flag-PROG "CC" "$1"; }
393
394# @FUNCTION: test-flag-CXX
395# @USAGE: <flag>
396# @DESCRIPTION:
397# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
398test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
399
400# @FUNCTION: test-flag-F77
401# @USAGE: <flag>
402# @DESCRIPTION:
403# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
404test-flag-F77() { test-flag-PROG "F77" "$1"; }
405
406# @FUNCTION: test-flag-FC
407# @USAGE: <flag>
408# @DESCRIPTION:
409# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
410test-flag-FC() { test-flag-PROG "FC" "$1"; }
411
412test-flags-PROG() {
413 local comp=$1
414 local flags
415 local x
416
417 shift
418
419 [[ -z ${comp} ]] && return 1
420
421 x=""
422 for x in "$@" ; do
423 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
424 done
425
426 echo "${flags}"
427
428 # Just bail if we dont have any flags
429 [[ -n ${flags} ]]
430}
431
432# @FUNCTION: test-flags-CC
433# @USAGE: <flags>
434# @DESCRIPTION:
435# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
436test-flags-CC() { test-flags-PROG "CC" "$@"; }
437
438# @FUNCTION: test-flags-CXX
439# @USAGE: <flags>
440# @DESCRIPTION:
441# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
442test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
443
444# @FUNCTION: test-flags-F77
445# @USAGE: <flags>
446# @DESCRIPTION:
447# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
448test-flags-F77() { test-flags-PROG "F77" "$@"; }
449
450# @FUNCTION: test-flags-FC
451# @USAGE: <flags>
452# @DESCRIPTION:
453# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
454test-flags-FC() { test-flags-PROG "FC" "$@"; }
455
456# @FUNCTION: test-flags
457# @USAGE: <flags>
458# @DESCRIPTION:
459# Short-hand that should hopefully work for both C and C++ compiler, but
460# its really only present due to the append-flags() abomination.
461test-flags() { test-flags-CC "$@"; }
462
463# @FUNCTION: test_flag
464# @DESCRIPTION:
465# DEPRICIATED, use test-flags()
269test_flag() { 466test_flag() {
270 local cc=${CC:-gcc} ; cc=${cc%% *} 467 ewarn "test_flag: deprecated, please use test-flags()!" >&2
271 if ${cc} -S -xc "$@" -o "$(emktemp)" /dev/null &>/dev/null; then
272 printf "%s\n" "$*"
273 return 0
274 fi
275 return 1
276}
277 468
469 test-flags-CC "$@"
470}
471
472# @FUNCTION: test_version_info
473# @USAGE: <version>
474# @DESCRIPTION:
475# Returns shell true if the current C compiler version matches <version>, else returns shell false.
476# Accepts shell globs.
278test_version_info() { 477test_version_info() {
279 local cc=${CC:-gcc} ; cc=${cc%% *}
280 if [[ $(${cc} --version 2>&1) == *$1* ]]; then 478 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
281 return 0 479 return 0
282 else 480 else
283 return 1 481 return 1
284 fi 482 fi
285} 483}
286 484
485# @FUNCTION: strip-unsupported-flags
486# @DESCRIPTION:
487# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
287strip-unsupported-flags() { 488strip-unsupported-flags() {
288 local NEW_CFLAGS NEW_CXXFLAGS 489 export CFLAGS=$(test-flags-CC ${CFLAGS})
289 490 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
290 for x in ${CFLAGS} ; do 491 export FFLAGS=$(test-flags-F77 ${FFLAGS})
291 NEW_CFLAGS="${NEW_CFLAGS} `test_flag ${x}`" 492 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
292 done
293 for x in ${CXXFLAGS} ; do
294 NEW_CXXFLAGS="${NEW_CXXFLAGS} `test_flag ${x}`"
295 done
296
297 export CFLAGS="${NEW_CFLAGS}"
298 export CXXFLAGS="${NEW_CXXFLAGS}"
299} 493}
300 494
495# @FUNCTION: get-flag
496# @USAGE: <flag>
497# @DESCRIPTION:
498# Find and echo the value for a particular flag. Accepts shell globs.
301get-flag() { 499get-flag() {
302 local f findflag="$1" 500 local f findflag="$1"
303 501
304 # this code looks a little flaky but seems to work for 502 # this code looks a little flaky but seems to work for
305 # everything we want ... 503 # everything we want ...
306 # for example, if CFLAGS="-march=i686": 504 # for example, if CFLAGS="-march=i686":
307 # `get-flag -march` == "-march=i686" 505 # `get-flag -march` == "-march=i686"
308 # `get-flag march` == "i686" 506 # `get-flag march` == "i686"
309 for f in ${CFLAGS} ${CXXFLAGS} ; do 507 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
310 if [ "${f/${findflag}}" != "${f}" ] ; then 508 if [ "${f/${findflag}}" != "${f}" ] ; then
311 printf "%s\n" "${f/-${findflag}=}" 509 printf "%s\n" "${f/-${findflag}=}"
312 return 0 510 return 0
313 fi 511 fi
314 done 512 done
315 return 1 513 return 1
316} 514}
317 515
516# @FUNCTION: has_hardened
517# @DESCRIPTION:
518# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
318has_hardened() { 519has_hardened() {
520 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
521
319 test_version_info Hardened && return 0 522 test_version_info Hardened && return 0
320 # the specs file wont exist unless gcc has GCC_SPECS support 523 # The specs file wont exist unless gcc has GCC_SPECS support
321 [ -f "${GCC_SPECS}" -a "${GCC_SPECS}" != "${GCC_SPECS/hardened/}" ] && \ 524 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
322 return 0
323 return 1
324} 525}
325 526
527# @FUNCTION: has_pic
528# @DESCRIPTION:
529# DEPRECATED - use gcc-specs-pie from toolchain-funcs
530# indicate whether PIC is set
326has_pic() { 531has_pic() {
327 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 532 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
328 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0
329 test_version_info pie && return 0
330 return 1
331}
332 533
534 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
535 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
536 gcc-specs-pie
537}
538
539# @FUNCTION: has_pie
540# @DESCRIPTION:
541# DEPRECATED - use gcc-specs-pie from toolchain-funcs
542# indicate whether PIE is set
333has_pie() { 543has_pie() {
334 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 544 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
335 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 545
336 test_version_info pie && return 0 546 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
337 return 1 547 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
548 gcc-specs-pie
338} 549}
339 550
551# @FUNCTION: has_ssp_all
552# @DESCRIPTION:
553# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
554# indicate whether code for SSP is being generated for all functions
555has_ssp_all() {
556 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
557
558 # note; this matches only -fstack-protector-all
559 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
560 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
561 gcc-specs-ssp-all
562}
563
564# @FUNCTION: has_ssp
565# @DESCRIPTION:
566# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
567# indicate whether code for SSP is being generated
340has_ssp() { 568has_ssp() {
569 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
570
571 # note; this matches both -fstack-protector and -fstack-protector-all
341 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0 572 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
342 test_version_info ssp && return 0 573 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
343 return 1 574 gcc-specs-ssp
344} 575}
345 576
577# @FUNCTION: has_m64
578# @DESCRIPTION:
579# This doesn't test if the flag is accepted, it tests if the flag actually
580# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
581# return code is 0, else the return code is 1.
346has_m64() { 582has_m64() {
347 # this doesnt test if the flag is accepted, it tests if the flag 583 # this doesnt test if the flag is accepted, it tests if the flag
348 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 584 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
349 # please dont replace this function with test_flag in some future 585 # please dont replace this function with test_flag in some future
350 # clean-up! 586 # clean-up!
587
351 local temp="$(emktemp)" 588 local temp="$(emktemp)"
352 echo "int main() { return(0); }" > ${temp}.c 589 echo "int main() { return(0); }" > "${temp}".c
590 MY_CC=$(tc-getCC)
353 ${CC/ .*/} -m64 -o "$(emktemp)" ${temp}.c > /dev/null 2>&1 591 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
354 local ret=$? 592 local ret=$?
355 rm -f ${temp}.c 593 rm -f "${temp}".c
356 [ "$ret" != "1" ] && return 0 594 [[ ${ret} != 1 ]] && return 0
357 return 1 595 return 1
358} 596}
359 597
598# @FUNCTION: has_m32
599# @DESCRIPTION:
600# This doesn't test if the flag is accepted, it tests if the flag actually
601# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
602# code is 0, else return code is 1.
360has_m32() { 603has_m32() {
361 # this doesnt test if the flag is accepted, it tests if the flag 604 # this doesnt test if the flag is accepted, it tests if the flag
362 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 605 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
363 # please dont replace this function with test_flag in some future 606 # please dont replace this function with test_flag in some future
364 # clean-up! 607 # clean-up!
608
609 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
610
365 local temp="$(emktemp)" 611 local temp=$(emktemp)
366 echo "int main() { return(0); }" > ${temp}.c 612 echo "int main() { return(0); }" > "${temp}".c
613 MY_CC=$(tc-getCC)
367 ${CC/ .*/} -m32 -o "$(emktemp)" ${temp}.c > /dev/null 2>&1 614 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
368 local ret=$? 615 local ret=$?
369 rm -f ${temp}.c 616 rm -f "${temp}".c
370 [ "$ret" != "1" ] && return 0 617 [[ ${ret} != 1 ]] && return 0
371 return 1 618 return 1
372} 619}
373 620
621# @FUNCTION: replace-sparc64-flags
622# @DESCRIPTION:
623# Sets mcpu to v8 and uses the original value as mtune if none specified.
374replace-sparc64-flags() { 624replace-sparc64-flags() {
375 local SPARC64_CPUS="ultrasparc v9" 625 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
376 626
377 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 627 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
378 for x in ${SPARC64_CPUS}; do 628 for x in ${SPARC64_CPUS}; do
379 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 629 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
380 done 630 done
381 else 631 else
382 for x in ${SPARC64_CPUS}; do 632 for x in ${SPARC64_CPUS}; do
383 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 633 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
384 done 634 done
385 fi 635 fi
386 636
387 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then 637 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
388 for x in ${SPARC64_CPUS}; do 638 for x in ${SPARC64_CPUS}; do
389 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 639 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
390 done 640 done
391 else 641 else
392 for x in ${SPARC64_CPUS}; do 642 for x in ${SPARC64_CPUS}; do
393 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 643 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
394 done 644 done
395 fi 645 fi
396 646
397 export CFLAGS CXXFLAGS 647 export CFLAGS CXXFLAGS
398} 648}
399 649
650# @FUNCTION: append-ldflags
651# @USAGE: <flags>
652# @DESCRIPTION:
653# Add extra <flags> to the current LDFLAGS.
400append-ldflags() { 654append-ldflags() {
655 [[ -z $* ]] && return 0
656 local flag
657 for flag in "$@"; do
658 [[ ${flag} == -l* ]] && \
659 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
660 done
661
401 export LDFLAGS="${LDFLAGS} $*" 662 export LDFLAGS="${LDFLAGS} $*"
402 return 0 663 return 0
403} 664}
404 665
666# @FUNCTION: filter-ldflags
667# @USAGE: <flags>
668# @DESCRIPTION:
669# Remove particular <flags> from LDFLAGS. Accepts shell globs.
405filter-ldflags() { 670filter-ldflags() {
406 local x 671 _filter-var LDFLAGS "$@"
672 return 0
673}
407 674
408 # we do this fancy spacing stuff so as to not filter 675# @FUNCTION: raw-ldflags
409 # out part of a flag ... we want flag atoms ! :D 676# @USAGE: <flags>
410 LDFLAGS=" ${LDFLAGS} " 677# @DESCRIPTION:
678# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
679# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
680# to gcc where it needs the '-Wl,'.
681raw-ldflags() {
682 local x input="$@"
683 [[ -z ${input} ]] && input=${LDFLAGS}
684 set --
411 for x in "$@" ; do 685 for x in ${input} ; do
412 LDFLAGS="${LDFLAGS// ${x} / }" 686 x=${x#-Wl,}
687 set -- "$@" ${x//,/ }
413 done 688 done
414 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 689 echo "$@"
415 export LDFLAGS
416 return 0
417} 690}
418 691
419etexec-flags() { 692# @FUNCTION: bindnow-flags
420 # if you're not using a hardened compiler you wont need this 693# @RETURN: Returns the flags to enable "now" binding in the current selected linker.
421 # PIC/no-pic kludge in the first place. 694# @DESCRIPTION:
422 has_hardened || return 0 695# DEPRECATED - Gets the flags needed for "NOW" binding
423 # this kludge breaks on amd64, and probably other -fPIC dependant 696bindnow-flags() {
424 # archs. 697 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild"
425 use amd64 && return 0
426
427 if has_pie || has_pic; then
428 [ -z "`is-flag -fno-pic`" ] &&
429 export CFLAGS="${CFLAGS} `test_flag -fno-pic`"
430 [ -z "`is-flag -nopie`" ] &&
431 export CFLAGS="${CFLAGS} `test_flag -nopie`"
432 fi
433 return 0
434} 698}
435 699
436fstack-flags() {
437 if has_ssp; then
438 [ -z "`is-flag -fno-stack-protector`" ] &&
439 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`"
440 fi
441 return 0
442}
443 700
444# This is thanks to great work from Paul de Vrieze <gentoo-user@devrieze.net>, 701# Some tests for when we screw with things and want to make
445# bug #9016. Also thanks to Jukka Salmi <salmi@gmx.net> (bug #13907) for more 702# sure we didn't break anything
446# fixes. 703#TESTS() {
704# CFLAGS="-a -b -c=1"
705# CXXFLAGS="-x -y -z=2"
706# LDFLAGS="-l -m -n=3"
447# 707#
448# Export CFLAGS and CXXFLAGS that are compadible with gcc-2.95.3 708# die() { exit 1; }
449gcc2-flags() { 709# (is-flag 1 2 3) && die
450 CFLAGS=${CFLAGS//pentium-mmx/i586} 710# (is-ldflag 1 2 3) && die
451 CFLAGS=${CFLAGS//pentium[234]/i686} 711#
452 CFLAGS=${CFLAGS//k6-[23]/k6} 712# is-flagq -l && die
453 CFLAGS=${CFLAGS//athlon-tbird/i686} 713# is-ldflagq -a && die
454 CFLAGS=${CFLAGS//athlon-4/i686} 714# is-flagq -a || die
455 CFLAGS=${CFLAGS//athlon-[xm]p/i686} 715# is-flagq -x || die
456 CFLAGS=${CFLAGS//athlon/i686} 716# is-ldflagq -n=* || die
457 717# is-ldflagq -n && die
458 CXXFLAGS=${CXXFLAGS//pentium-mmx/i586} 718#
459 CXXFLAGS=${CXXFLAGS//pentium[234]/i686} 719# strip-unsupported-flags
460 CXXFLAGS=${CXXFLAGS//k6-[23]/k6} 720# [[ ${CFLAGS} == "-c=1" ]] || die
461 CXXFLAGS=${CXXFLAGS//athlon-tbird/i686} 721# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
462 CXXFLAGS=${CXXFLAGS//athlon-4/i686} 722#
463 CXXFLAGS=${CXXFLAGS//athlon-[xm]p/i686} 723# echo "All tests pass"
464 CXXFLAGS=${CXXFLAGS//athlon/i686} 724#}
465 725#TESTS
466 if [ "$ARCH" = alpha ]; then
467 CHOST=${CHOST/#alphaev6[78]/alphaev6}
468 CFLAGS=${CFLAGS//ev6[78]/ev6}
469 CXXFLAGS=${CXXFLAGS//ev6[78]/ev6}
470 fi
471
472 export CFLAGS CXXFLAGS
473}

Legend:
Removed from v.1.73  
changed lines
  Added in v.1.129

  ViewVC Help
Powered by ViewVC 1.1.20